import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
/**
 * Write a description of class Unit here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Unit  extends AllyPlacer
{
    private int counter;
    static int Health = 100;//ally's health
    private int healthRegenCount;//ally's health regeneration speed
    static int Gun = 0;//ally's gun
                       //works just like tyler's but won't do anything
                       //i'm still working on able to give your ally your gun
    HUD allyHealth = new HUD("allyhealth");//create ally's health bar
    List<Zobi> enemy;//zobi list
    GreenfootImage[] images = new GreenfootImage[3];//images of Stece(name i made in diablo 2 a million years ago)
    public Unit() {
        Health = 100;
    }
    
    protected void addedToWorld(World world) {
        getWorld().addObject(allyHealth,105,28);
        images[0] = new GreenfootImage("Ally/Stece[pistol].png");
        images[1] = new GreenfootImage("Ally/Stece[minigun].png");
        images[2] = new GreenfootImage("Ally/Stece[flamethrower].png");
        setImage(images[Gun]);
    }
    
    public void act() {
        setLocation((int)AllyPlacer.x,(int)AllyPlacer.y);//have ally always on top of placer
        setImage(images[Gun]);//set image to current gun image
        if(Gun == 0) {//if Stece has a pistol do these actions
            enemy = getObjectsInRange(300,Zobi.class);//get zobi's nearby
            if(enemy.size() > 0) {//if list has zobi's do these actions
                Zobi zobi = enemy.get(0);//get last zobi in list
                setRotation(pointTo(zobi.getX(),zobi.getY()));//look at that zobi
                counter++;
                if(counter == 15) {//shoot
                    getWorld().addObject(new Bullet((getRotation() - 5) + Greenfoot.getRandomNumber(10)),getX(),getY());
                    counter = 0;
                }
            } else {//if no zobi's nearby look opposite of Tyler
                setRotation(Tyler.facing - 180);
            }
        } else if(Gun == 1) {//if Stece has a minigun do these actions
            enemy = getObjectsInRange(250,Zobi.class);//get zobi's nearby
            if(enemy.size() > 0) {//if list has zobi's do these actions
                Zobi zobi = enemy.get(0);//get last zobi in list
                setRotation(pointTo(zobi.getX(),zobi.getY()));//look at zobi
                getWorld().addObject(new Bullet((getRotation() - 5) + Greenfoot.getRandomNumber(10)),getX(),getY());//shoot
            } else {//if no zobi's nearby look opposite of Tyler
                setRotation(Tyler.facing - 180);
            }
        } else if(Gun == 2) {//if Stece has a flamethrower do these actions
            enemy = getObjectsInRange(200,Zobi.class);//get zobi's nearby
            if(enemy.size() > 0) {//if list has zobi's do these actions
                Zobi zobi = enemy.get(0);//get last zobi in list
                setRotation(pointTo(zobi.getX(),zobi.getY()));//look at zobi
                for(int i=0;i<Greenfoot.getRandomNumber(5) + 5;i++)//create 5 fire's
                    getWorld().addObject(new Fire((getRotation() - 10) + Greenfoot.getRandomNumber(20)),getX(),getY());//shoot
            } else {//if no zobi's nearby look opposite of Tyler
                setRotation(Tyler.facing - 180);
            }
        }
        HealthRegen();//regenerate health if no zobi's nearby
    }

    public int pointTo(int x, int y) {
        int dX = x - getX(); 
        int dY = y - getY(); 
        double rotation = Math.atan2(dY, dX); 
        rotation = Math.toDegrees(rotation); 
        return (int)rotation; 
    } 
    
    public void HealthRegen() {
        List<Zobi> Zobi = getObjectsInRange(20,Zobi.class);
        /** getting attacked */
        if(Zobi.size() == 0 && healthRegenCount == 3) {//if no zobi's nearby regenerate health
            Health++;
            if(Health >= 100)
                Health = 100;
            healthRegenCount = 0;
        } else if(healthRegenCount < 3) {
            healthRegenCount++;
        }
        Die();//check whether dead or not
    }
    
    public void Die() {
        /** create player body parts upon death */
        if(Health <= 0) {//create body parts of ally
            //getWorld().addObject(new bodyParts("arm",Greenfoot.getRandomNumber(5) + 2,Greenfoot.getRandomNumber(15) + 10,Greenfoot.getRandomNumber(360),Greenfoot.getRandomNumber(360)),getX(), getY());
            //getWorld().addObject(new bodyParts("arm",Greenfoot.getRandomNumber(5) + 2,Greenfoot.getRandomNumber(15) + 10,Greenfoot.getRandomNumber(360),Greenfoot.getRandomNumber(360)),getX(), getY());
            //getWorld().addObject(new bodyParts("leg",Greenfoot.getRandomNumber(5) + 2,Greenfoot.getRandomNumber(15) + 10,Greenfoot.getRandomNumber(360),Greenfoot.getRandomNumber(360)),getX(), getY());
            //getWorld().addObject(new bodyParts("leg",Greenfoot.getRandomNumber(5) + 2,Greenfoot.getRandomNumber(15) + 10,Greenfoot.getRandomNumber(360),Greenfoot.getRandomNumber(360)),getX(), getY());
            //getWorld().addObject(new bodyParts("head",Greenfoot.getRandomNumber(5) + 2,Greenfoot.getRandomNumber(15) + 10,Greenfoot.getRandomNumber(360),Greenfoot.getRandomNumber(360)),getX(), getY());
            //getWorld().addObject(new bodyParts("body",Greenfoot.getRandomNumber(5) + 2,Greenfoot.getRandomNumber(15) + 10,Greenfoot.getRandomNumber(360),Greenfoot.getRandomNumber(360)),getX(), getY());
            //getWorld().addObject(new Stats(),-300,getWorld().getHeight()/2);
            getWorld().addObject(new Blood(Greenfoot.getRandomNumber(360),Greenfoot.getRandomNumber(3)+2,Greenfoot.getRandomNumber(5)+3),getX(),getY());
            getWorld().removeObject(this);
        }
    }
}
