import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Write a description of class Zobi here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Zobi  extends Actor
{
    private int attackCount = 15;
    /** speed of Zombies */
    private int Speed = 1;
    /** location of Zombies */
    private double x, y;
    /** direction zobi is facing */
    private int facing;
    private int Counter;
    /** total health of zobi */
    private int Health = 100;
    /** images of zobi */
    private GreenfootImage[] imgs = new GreenfootImage[4];
    private int currentImage = 0;
    private int imgCount;
    private int who;//who are you attacking fred?
    public Zobi(int Direction,int personToAttack) {
        facing = Direction;
        who = personToAttack;
    }
    
    protected void addedToWorld(World world) {
        x = getX();
        y = getY();
        setRotation(facing);
        assign_IMAGES();
        currentImg();
        /** Work in progress */
        if(((myWorld) getWorld()).currentWave % 5 == 0)
            statIncrease();
    }
    
    public void currentImg() {
        setImage(imgs[currentImage]);
    }
    
    public void assign_IMAGES() {
        imgs[0] = new GreenfootImage("Zombies/BasicZobi[1].png");
        imgs[1] = new GreenfootImage("Zombies/BasicZobi[2].png");
        imgs[2] = new GreenfootImage("Zombies/BasicZobi[3].png");
        imgs[3] = new GreenfootImage("Zombies/BasicZobi[4].png");
    }
    
    public void act() {
        List<Unit> ally = getWorld().getObjects(Unit.class);//get number of ally's in the world
        if(ally.size() == 1) {//if there is an ally then choose who to go after
            if(who == 0)
                MovementTyler();
            if(who == 1)
                MovementAlly();
        } else {//but if there is no ally then just attack Tyler
            MovementTyler();
        }
        ChangingImage();//set image according to health
        gettingShot();//BANG!
    }    
    
    public void MovementTyler() {
        List<Tyler> Player = getWorld().getObjects(Tyler.class);//get the Tyler's in the world
        if(Player.size() > 0) {//if there is a Tyler
            Tyler tyler = Player.get(0);//then get the only Tyler
            setRotation(pointTo(tyler.getX(),tyler.getY()));//look at Tyler
            facing = getRotation();//set Var value
            moveTowardsTyler();//move towards Tyler
        } else {
            /**
             * not necessary code, for zobi's just go after people now. there not lazy like they use
             * to be. just wondering around til someone was close or they got shot at. guess they realized
             * that's not the way to go
             */
            Counter++;
            if(Counter == 15) {
                int numGen = Greenfoot.getRandomNumber(2);
                if(numGen == 0) {
                    facing+=15;
                    //if(facing == 360)
                    //    facing = 0;
                    setRotation(facing);
                    Counter = 0;
                    } else {
                    facing-=15;
                    //if(facing == 0)
                    //    facing = 360;
                    setRotation(facing);
                    Counter = 0;
                }
            }
        }
    }
    
    public void MovementAlly() {
        List<Unit> ally = getWorld().getObjects(Unit.class);//get Stece in the world
        if(ally.size() > 0) {//if there is a Stece
            Unit unit = ally.get(0);//then get the only Stece
            setRotation(pointTo(unit.getX(),unit.getY()));//look at Stece
            facing = getRotation();//set var value
            moveTowardsAlly();//attack Stece!
        } else {
            /**
             * ^ Ditto :p^
             */
            Counter++;
            if(Counter == 15) {
                int numGen = Greenfoot.getRandomNumber(2);
                if(numGen == 0) {
                    facing+=15;
                    //if(facing == 360)
                    //    facing = 0;
                    setRotation(facing);
                    Counter = 0;
                    } else {
                    facing-=15;
                    //if(facing == 0)
                    //    facing = 360;
                    setRotation(facing);
                    Counter = 0;
                }
            }
        }
    }
    
    public int pointTo(int x, int y) {
        int dX = x - getX(); 
        int dY = y - getY(); 
        double rotation = Math.atan2(dY, dX); 
        rotation = Math.toDegrees(rotation); 
        return (int)rotation; 
    } 

    public void moveTowardsTyler() {
        List<Tyler> Tyler = getObjectsInRange(15,Tyler.class);//see if Tyler is really close
        if(Tyler.size() == 0) {//if he's not then move towards him
            double angle = Math.toRadians(getRotation());
            x+=Math.cos(angle)*Speed;
            y+=Math.sin(angle)*Speed;
            setLocation((int)Math.round(x), (int)Math.round(y));
        } else {//but when he is close don't move and attack!
            Tyler player = Tyler.get(0);
            setLocation((int)Math.round(x), (int)Math.round(y));
            if(attackCount == 15) {
                player.Health-=5;
                for(int w=0;w<Greenfoot.getRandomNumber(50) + 25;w++)
                    getWorld().addObject(new Blood(Greenfoot.getRandomNumber(360),Greenfoot.getRandomNumber(5)+2,Greenfoot.getRandomNumber(5)+2),player.getX(),player.getY());
                for(int u=0;u<Greenfoot.getRandomNumber(50) + 25;u++)
                    getWorld().addObject(new Blood(getRotation(),Greenfoot.getRandomNumber(5) + 5,Greenfoot.getRandomNumber(10) + 5),getX(),getY());
                attackCount = 0;
            } else if(attackCount < 15){
                attackCount++;
            }
        }
    }
    
    public void moveTowardsAlly() {
        List<Unit> ally = getObjectsInRange(15,Unit.class);//see if Stece is really close
        if(ally.size() == 0) {//if he's not then move towards him
            double angle = Math.toRadians(getRotation());
            x+=Math.cos(angle)*Speed;
            y+=Math.sin(angle)*Speed;
            setLocation((int)Math.round(x), (int)Math.round(y));
        } else {//but when he is close don't move and attack!
            Unit unit = ally.get(0);
            setLocation((int)Math.round(x), (int)Math.round(y));
            if(attackCount == 15) {
                Unit.Health-=5;
                for(int w=0;w<Greenfoot.getRandomNumber(50) + 25;w++)
                    getWorld().addObject(new Blood(Greenfoot.getRandomNumber(360),Greenfoot.getRandomNumber(5)+2,Greenfoot.getRandomNumber(5)+2),unit.getX(),unit.getY());
                for(int u=0;u<Greenfoot.getRandomNumber(50) + 25;u++)
                    getWorld().addObject(new Blood(getRotation(),Greenfoot.getRandomNumber(5) + 5,Greenfoot.getRandomNumber(10) + 5),getX(),getY());
                attackCount = 0;
            } else if(attackCount < 15){
                attackCount++;
            }
        }
    }
    
    public void gettingShot() {
        Bullet bullet = (Bullet)getOneIntersectingObject(Bullet.class);//get bullet
        Shrapnel shard = (Shrapnel)getOneIntersectingObject(Shrapnel.class);//get shard
        Fire fire = (Fire)getOneIntersectingObject(Fire.class);//get fire!!
        if(bullet != null && Health >= 0 ) {//if shot by bullet
            /** Push zobi in direction bullet is traveling */
            double angle = Math.toRadians(bullet.Direction);
            x += Math.cos(angle)*(Speed*5);
            y += Math.sin(angle)*(Speed*5);
            setLocation((int)Math.round(x), (int)Math.round(y));
            /** Create blood splatter */
            for(int b=0;b<Greenfoot.getRandomNumber(50)+50;b++)
                getWorld().addObject(new Blood(bullet.Direction,Greenfoot.getRandomNumber(5) + 5,Greenfoot.getRandomNumber(10) + 5),getX(),getY());
            /** subtract health */
            Health-=20;
            /** Remove bullet */
            getWorld().removeObject(bullet);
            /** if no health delete zobi */
            if(Health <= 0) {
                for(int d=0;d<Greenfoot.getRandomNumber(50)+100;d++)
                    getWorld().addObject(new Blood(Greenfoot.getRandomNumber(360),Greenfoot.getRandomNumber(5) + 2,Greenfoot.getRandomNumber(8) + 2),getX(),getY());
                dropItem();//try and drop there loot
                if(Tyler.Gun == 0)//if killed by pistol add to total pitol kills
                    Tyler.pistolKills++;
                if(Tyler.Gun == 1)//if killed by machinegun add to total machinegun kills
                    Tyler.minigunKills++;
                getWorld().removeObject(this);//delete zobi
            }
        } else if(shard != null && Health >= 0) {//if shot by shard
            /** Push zobi in direction bullet is traveling */
            double angle = Math.toRadians(shard.Direction);
            x += Math.cos(angle)*(Speed*5);
            y += Math.sin(angle)*(Speed*5);
            setLocation((int)Math.round(x), (int)Math.round(y));
            /** Create blood splatter */
            for(int b=0;b<Greenfoot.getRandomNumber(50)+50;b++)
                getWorld().addObject(new Blood(shard.Direction,Greenfoot.getRandomNumber(5) + 5,Greenfoot.getRandomNumber(10) + 5),getX(),getY());
            /** subtract health */
            Health-=15;
            /** Remove bullet */
            getWorld().removeObject(shard);
            /** if no health delete zobi */
            if(Health <= 0) {
                for(int d=0;d<Greenfoot.getRandomNumber(50)+100;d++)
                    getWorld().addObject(new Blood(Greenfoot.getRandomNumber(360),Greenfoot.getRandomNumber(5) + 2,Greenfoot.getRandomNumber(8) + 2),getX(),getY());
                dropItem();//drop your loot!
                Tyler.landmineKills++;//add to land mine kills
                getWorld().removeObject(this);//delete zobi
            }
        }  else if(fire != null && Health >= 0) {//if shot by fire
            /** subtract health */
            Health-=8;
            /** if no health delete zobi */
            if(Health <= 0) {
                for(int d=0;d<Greenfoot.getRandomNumber(50)+250;d++)
                    getWorld().addObject(new Blood(Greenfoot.getRandomNumber(360),Greenfoot.getRandomNumber(5) + 2,Greenfoot.getRandomNumber(8) + 2),getX(),getY());
                dropItem();//you can't hide your items
                Tyler.flamethrowerKills++;//add to flamethrower kills
                getWorld().removeObject(this);//delete zobi
            }
        }
    }

    public void ChangingImage() {
        if(Health >= 75)//it's just a scratch
            setImage(imgs[0]);
        if(Health < 75 && Health >= 50)//don't be a baby
            setImage(imgs[1]);
        if(Health < 50 && Health >= 25)//stop crying
            setImage(imgs[2]);
        if(Health < 25 && Health > 0)//okay, you might be hurt
            setImage(imgs[3]);
    }
    
    public void dropItem() {
        int RanItem = Greenfoot.getRandomNumber(100);
        if(RanItem <= 10)//drop a pistol
            getWorld().addObject(new Guns(0),getX(),getY());
        if(RanItem > 10 && RanItem <= 15)//drop a machinegun
            getWorld().addObject(new Guns(1),getX(),getY());
        if(RanItem > 15 && RanItem <= 20)//drop a flamethrower
            getWorld().addObject(new Guns(2),getX(),getY());
    }
    
    /**
     * still working on it
     */
    public void statIncrease() {
        Health += 50;
    }
}
