import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.*;
/**
 * Write a description of class Bursts here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Blood  extends Actor
{
    private int Cleaner;//when to disappear
    private int Timer;//when to stop
    private int facing;//direction
    private double x,y;//X and Y-coordinates
    private int Speed;//speed of blood drop
    GreenfootImage image;
    public Blood(int direction,int Speed,int Timer) {//fun setup
        this.Timer = Timer;//make class var equal to given var
        this.Speed = Speed;//make class var equal to given var
        facing = (direction - 25) + Greenfoot.getRandomNumber(50);//tell which direction to travel from given direction
        int x = Greenfoot.getRandomNumber(2) + 2;//image width
        int y = Greenfoot.getRandomNumber(2) + 2;//image height
        image = new GreenfootImage(x,y);//create image
        int transparency = Greenfoot.getRandomNumber(150) + 50;//transparency of image
        image.setColor(new Color(255,0,0,transparency));//set color and transparency of image
        image.fill();//fill image
        setImage(image);//set image
    }
    
    protected void addedToWorld(World world) {
        x = getX();//assign X-coordinate
        y = getY();//assign Y-coordinate
    }
    
    public void act() {
        move();//move the blood drop
        Cleaner++;//Cleaner countup
        if(getImage().getTransparency() < 25) {
            getWorld().removeObject(this);//delete blood drop if unable to see it
        } else if(Cleaner == 10) {//slowly fade blood drop away into nothingness
            GreenfootImage img = getImage();
            img.setTransparency(getImage().getTransparency() - 15);
            Cleaner = 0;//reset variable
            setImage(img);//update image
        }
    }    
    
    public void move() {
        Timer--;//travel countdown
        if(Timer > 0) {//if timer doesn't equals 0 then move blood drop move!!
            double angle = Math.toRadians(facing);
            x+=Math.cos(angle)*Speed;
            y+=Math.sin(angle)*Speed;
            setLocation((int)Math.round(x), (int)Math.round(y));
        }
    }
}
