import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.*;
/**
 * Write a description of class Fire here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Fire  extends PROJECTILES
{
    GreenfootImage image;//image
    private int Speed = 5;//speed
    private int Direction;//direction
    private double x,y;//X and Y-coordinates
    protected void addedToWorld(World world) {
        x = getX();//assign X-coordinate
        y = getY();//assign Y-coordinate
    }
    
    public Fire(int d) {
        Direction = d;//which direction to travel
        int x = Greenfoot.getRandomNumber(3) + 2;//set image width
        int y = Greenfoot.getRandomNumber(3) + 2;//set image height
        int t = Greenfoot.getRandomNumber(150) + 105;//set image transparency
        image = new GreenfootImage(x,y);//create image
        image.setColor(new Color(255,100,0,t));//set image properties
        image.fill();//fill image
        setImage(image);//set image
    }
    
    public void act() {//movement code
        double angle = Math.toRadians(Direction);
        x+=Math.cos(angle)*Speed;
        y+=Math.sin(angle)*Speed;
        setLocation((int)Math.round(x), (int)Math.round(y));
        if(getImage().getTransparency() < 25) {
            getWorld().removeObject(this);//delete after awhile
        } else {
            GreenfootImage img = getImage();
            img.setTransparency(getImage().getTransparency() - 5);
            setImage(img);
        }
    }    
}
