import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.*;
/**
 * Write a description of class Fire here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Shrapnel  extends PROJECTILES
{
    GreenfootImage image;//image
    private int Speed = 5;//speed of object
    public int Direction;//direction object will be traveling
    private double x,y;//X and Y coordinate var's
    protected void addedToWorld(World world) {
        x = getX();//assign X-coordinate
        y = getY();//assign Y-coordinate
    }
    
    public Shrapnel(int d) {
        Direction = d;//set direction object will be traveling
        int x = Greenfoot.getRandomNumber(3) + 1;//get random image width
        int y = Greenfoot.getRandomNumber(3) + 1;//get random image height
        image = new GreenfootImage(x,y);//create image
        int T = Greenfoot.getRandomNumber(75)+175;//set image's transparency
        image.setColor(new Color(0,0,0,T));//set image color
        image.fill();//fill in image
        setImage(image);//set image
    }
    
    public void act() {//movement code
        double angle = Math.toRadians(Direction);
        x+=Math.cos(angle)*Speed;
        y+=Math.sin(angle)*Speed;
        setLocation((int)Math.round(x), (int)Math.round(y));
        if(getImage().getTransparency() < 25) {
            getWorld().removeObject(this);//delete object after awhile
        } else {
            GreenfootImage img = getImage();
            img.setTransparency(getImage().getTransparency() - 10);
            setImage(img);
        }
    }    
}
