import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
/**
 * Write a description of class myWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class myWorld  extends World
{
    private int Counter;
    private int Frequency = 70;//how often zobi created
    static int numOfZobis;//number of zobi's
    //static int[] numOfZobis = new int[30];
    private boolean spawn = false;//spawn determination
    static int currentWave = 0;//wave number
    private int z = 25;//number added to numOfZobis after each wave
    private int startCounter;
    public myWorld() {
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600,600,1,false); 
        Greenfoot.setSpeed(50);
        setPaintOrder(Stats.class,Text.class,HUD.class,Guns.class,Zobi.class,Tyler.class,Unit.class,bodyParts.class,Blood.class,Currentwave.class);
        addObject(new Tyler(),(getWidth()/2) + 10,getHeight()/2);
        addObject(new AllyPlacer(),-25,-25);
        addObject(new Unit(),-25,-25);
        ResetVariables();//reset world variables when reset button clicked
    }
    
    public void act() {
        List<Zobi> onMap = getObjects(Zobi.class);
        if(spawn) {
            Counter++;
            if(Counter == Frequency) {
                int numGen = Greenfoot.getRandomNumber(4);
                if(numGen == 0)//middle left
                    addObject(new Zobi(0,Greenfoot.getRandomNumber(2)),0,Greenfoot.getRandomNumber(600));
                if(numGen == 1)//top middle
                    addObject(new Zobi(90,Greenfoot.getRandomNumber(2)),Greenfoot.getRandomNumber(600),0);
                if(numGen == 2)//right middle
                    addObject(new Zobi(180,Greenfoot.getRandomNumber(2)),600,Greenfoot.getRandomNumber(600));
                if(numGen == 3)//bosssssss
                    addObject(new Zobi(270,Greenfoot.getRandomNumber(2)),Greenfoot.getRandomNumber(600),600);
                Counter = 0;
                numOfZobis--;//subtract from current wave total
                if(numOfZobis == 0)//start next wave countdown if no zombies left on map
                    spawn = false;
            }
        } else if(onMap.size() == 0) {
            startCounter++;//countdown til next wave
            if(startCounter == 500) {//time's up
                spawn = true;//start spawning
                Tyler.totalMines+=2;//give player 2 more mines
                currentWave++;//add to next wave integer
                numOfZobis = currentWave*z;//make number of zobi's in next wave
                if(numOfZobis > 300)//only 300 zobi's per a level
                    numOfZobis = 300;
                if(Frequency > 15)//spawn zobi's more quickly every wave
                    Frequency -= 5;
                addObject(new Currentwave(),290,280);//tell player wave number
                startCounter = 0;//reset countdown
            }
        }
    }
    
    public void ResetVariables() {
        Frequency = 75;
        currentWave = 0;
    }
    
    /** 
     * first way i tried setting up number of zobi's in a wave.
     * worked when i had it so that there was an array with a 
     * total of 30 waves before i just made it an infinite game.
     */
    //public void initializeWaves() {
    //    for(int i=1;i<numOfZobis.length;i++) {
    //        if(numOfZobis[i-1] < 500) {
    //            numOfZobis[i] = numOfZobis[i-1] + z;
    //        }  else {
    //            numOfZobis[i] = 500;
    //        }
    //    }
    //}
}
